% script file BildRec.m
%%%%%%%%%%%%%%%%%%%%%%%%%

clc; clear all; close all;

load('kanten2.mat');
n = size(Edges1,1);

% Poisson matrix
A = PoissonMatrix_Dirichlet(1,n);

% rhs inside
Eins = Edges1(2:n-1,2:n-1);
Eins = reshape(Eins,[(n-2)^2,1]);

% boundary data
Bd = [Edges1(:,1); Edges1(n,2:n)'; Edges1(n-1:-1:1,n); Edges1(1,n-1:-1:2)'];


f = [Eins;Bd];

U = A\f;


Uins = U(1:(n-2)^2); % the inner grid points
Ubd = U((n-2)^2+1:end);

% stack together
UU = zeros(n,n);
UU(2:n-1,2:n-1) = reshape(Uins,[n-2,n-2]);

UU(1:n,1) = Ubd(1:n);
UU(n,2:n) = Ubd(n+1:2*n-1);
UU(n-1:-1:1,n) = Ubd(2*n:3*n-2);
UU(1,n-1:-1:2) = Ubd(3*n-1:end);



Bild1 = reshape(UU,[n,n]);

figure(1);
surf(Bild1);
shading flat
view(2);
axis ij
colormap('bone'); axis equal;
title('reconstructed image');
